Whamcloud - gitweb
LU-7558 ptlrpc: connect vs import invalidate race
[fs/lustre-release.git] / lustre / tests / functions.sh
index cada840..72ea7db 100644 (file)
@@ -1,6 +1,4 @@
 #!/bin/bash
-# -*- mode: Bash; tab-width: 4; indent-tabs-mode: t; -*-
-# vim:shiftwidth=4:softtabstop=4:tabstop=4:
 
 # Simple function used by run_*.sh scripts
 
@@ -285,24 +283,22 @@ print_opts () {
 }
 
 run_compilebench() {
-       # Space estimation:
-       # compile dir kernel-0  ~1GB
-       # required space        ~1GB * cbench_IDIRS
-
        local dir=${1:-$DIR}
+       local cbench_DIR=${cbench_DIR:-""}
+       local cbench_IDIRS=${cbench_IDIRS:-2}
+       local cbench_RUNS=${cbench_RUNS:-2}
 
-    cbench_DIR=${cbench_DIR:-""}
-    cbench_IDIRS=${cbench_IDIRS:-2}
-    cbench_RUNS=${cbench_RUNS:-2}
-
-    print_opts cbench_DIR cbench_IDIRS cbench_RUNS
+       print_opts cbench_DIR cbench_IDIRS cbench_RUNS
 
-    [ x$cbench_DIR = x ] &&
-        { skip_env "compilebench not found" && return; }
+       [ x$cbench_DIR = x ] &&
+               { skip_env "compilebench not found" && return; }
 
-    [ -e $cbench_DIR/compilebench ] || \
-        { skip_env "No compilebench build" && return; }
+       [ -e $cbench_DIR/compilebench ] ||
+               { skip_env "No compilebench build" && return; }
 
+       # Space estimation:
+       # compile dir kernel-0  ~1GB
+       # required space        ~1GB * cbench_IDIRS
        local space=$(df -P $dir | tail -n 1 | awk '{ print $4 }')
        if [[ $space -le $((1024 * 1024 * cbench_IDIRS)) ]]; then
                cbench_IDIRS=$((space / 1024 / 1024))
@@ -310,15 +306,16 @@ run_compilebench() {
                        skip_env "Need free space at least 1GB, have $space" &&
                        return
 
-               echo "free space=$space, reducing initial dirs to $cbench_IDIRS"
+               echo "reducing initial dirs to $cbench_IDIRS"
        fi
+       echo "free space = $space KB"
 
-    # FIXME:
-    # t-f _base needs to be modifyed to set properly tdir
-    # for new "test_foo" functions names
-    # local testdir=$DIR/$tdir
-    local testdir=$dir/d0.compilebench
-    mkdir -p $testdir
+       # FIXME:
+       # t-f _base needs to be modifyed to set properly tdir
+       # for new "test_foo" functions names
+       # local testdir=$DIR/$tdir
+       local testdir=$dir/d0.compilebench.$$
+       mkdir -p $testdir
 
     local savePWD=$PWD
     cd $cbench_DIR
@@ -337,32 +334,31 @@ run_compilebench() {
 }
 
 run_metabench() {
-
-    METABENCH=${METABENCH:-$(which metabench 2> /dev/null || true)}
-    mbench_NFILES=${mbench_NFILES:-30400}
-    # threads per client
-    mbench_THREADS=${mbench_THREADS:-4}
+       local dir=${1:-$DIR}
+       local mntpt=${2:-$MOUNT}
+       METABENCH=${METABENCH:-$(which metabench 2> /dev/null || true)}
+       mbench_NFILES=${mbench_NFILES:-30400}
+       # threads per client
+       mbench_THREADS=${mbench_THREADS:-4}
        mbench_OPTIONS=${mbench_OPTIONS:-}
+       mbench_CLEANUP=${mbench_CLEANUP:-true}
 
-    [ x$METABENCH = x ] &&
-        { skip_env "metabench not found" && return; }
+       [ x$METABENCH = x ] &&
+               { skip_env "metabench not found" && return; }
 
-    # FIXME
-    # Need space estimation here.
+       print_opts METABENCH clients mbench_NFILES mbench_THREADS
 
-    print_opts METABENCH clients mbench_NFILES mbench_THREADS
-
-    local testdir=$DIR/d0.metabench
-    mkdir -p $testdir
-    # mpi_run uses mpiuser
-    chmod 0777 $testdir
+       local testdir=$dir/d0.metabench
+       mkdir -p $testdir
+       # mpi_run uses mpiuser
+       chmod 0777 $testdir
 
-    # -C             Run the file creation tests.
-    # -S             Run the file stat tests.
-    # -c nfile       Number of files to be used in each test.
-    # -k             Cleanup.  Remove the test directories.
-       local cmd="$METABENCH -w $testdir -c $mbench_NFILES -C -S -k $mbench_OPTIONS"
-    echo "+ $cmd"
+       # -C             Run the file creation tests. Creates zero byte files.
+       # -S             Run the file stat tests.
+       # -c nfile       Number of files to be used in each test.
+       # -k             Cleanup files when finished.
+       local cmd="$METABENCH -w $testdir -c $mbench_NFILES -C -S $mbench_OPTIONS"
+       echo "+ $cmd"
 
        # find out if we need to use srun by checking $SRUN_PARTITION
        if [ "$SRUN_PARTITION" ]; then
@@ -374,11 +370,16 @@ run_metabench() {
                        -np $((num_clients * $mbench_THREADS)) $cmd
        fi
 
-    local rc=$?
-    if [ $rc != 0 ] ; then
-        error "metabench failed! $rc"
-    fi
-    rm -rf $testdir
+       local rc=$?
+       if [ $rc != 0 ] ; then
+               error "metabench failed! $rc"
+       fi
+
+       if $mbench_CLEANUP; then
+               rm -rf $testdir
+       else
+               mv $dir/d0.metabench $mntpt/_xxx.$(date +%s).d0.metabench
+       fi
 }
 
 run_simul() {
@@ -489,67 +490,90 @@ run_mdtest() {
 }
 
 run_connectathon() {
+       local dir=${1:-$DIR}
+       cnt_DIR=${cnt_DIR:-""}
+       cnt_NRUN=${cnt_NRUN:-10}
 
-    cnt_DIR=${cnt_DIR:-""}
-    cnt_NRUN=${cnt_NRUN:-10}
+       print_opts cnt_DIR cnt_NRUN
 
-    print_opts cnt_DIR cnt_NRUN
+       [ x$cnt_DIR = x ] &&
+               { skip_env "connectathon dir not found" && return; }
 
-    [ x$cnt_DIR = x ] &&
-        { skip_env "connectathon dir not found" && return; }
+       [ -e $cnt_DIR/runtests ] ||
+               { skip_env "No connectathon runtests found" && return; }
 
-    [ -e $cnt_DIR/runtests ] || \
-        { skip_env "No connectathon runtests found" && return; }
+       # Space estimation:
+       # "special" tests create a 30 MB file + misc. small files
+       # required space ~40 MB
+       local space=$(df -P $dir | tail -n 1 | awk '{ print $4 }')
+       if [[ $space -le $((1024 * 40)) ]]; then
+               skip_env "Need free space at least 40MB, have $space KB" &&
+               return
+       fi
+       echo "free space = $space KB"
 
-    local testdir=$DIR/d0.connectathon
-    mkdir -p $testdir
+       local testdir=$dir/d0.connectathon
+       mkdir -p $testdir
 
-    local savePWD=$PWD
-    cd $cnt_DIR
+       local savePWD=$PWD
+       cd $cnt_DIR
 
-    #
-    # cthon options (must be in this order)
-    #
-    # -N numpasses - will be passed to the runtests script.  This argument
-    #         is optional.  It specifies the number of times to run
-    #         through the tests.
-    #
-    # One of these test types
-    #    -b  basic
-    #    -g  general
-    #    -s  special
-    #    -l  lock
-    #    -a  all of the above
-    #
-    # -f      a quick functionality test
-    #
-
-    tests="-b -g -s"
-    # Include lock tests unless we're running on nfsv4
-    local fstype=$(df -TP $testdir | awk 'NR==2  {print $2}')
-    echo "$testdir: $fstype"
-    if [[ $fstype != "nfs4" ]]; then
-        tests="$tests -l"
-    fi
-    echo "tests: $tests"
-    for test in $tests; do
-        local cmd="./runtests -N $cnt_NRUN $test -f $testdir"
-        local rc=0
-
-        log "$cmd"
-        eval $cmd
-        rc=$?
-        [ $rc = 0 ] || error "connectathon failed: $rc"
-    done
+       #
+       # To run connectathon:
+       # runtests [-a|-b|-g|-s|-l] [-f|-n|-t] [-N numpasses] [test-directory]
+       #
+       # One of the following test types
+       #    -b  basic
+       #    -g  general
+       #    -s  special
+       #    -l  lock
+       #    -a  all of the above
+       #
+       # -f  a quick functional test
+       # -n  suppress directory operations (mkdir and rmdir)
+       # -t  run with time statistics (default for basic tests)
+       #
+       # -N numpasses - specifies the number of times to run
+       #                the tests. Optional.
+
+       tests="-b -g -s"
+       # Include lock tests unless we're running on nfsv4
+       local fstype=$(df -TP $testdir | awk 'NR==2  {print $2}')
+       echo "$testdir: $fstype"
+       if [[ $fstype != "nfs4" ]]; then
+               tests="$tests -l"
+       fi
+       echo "tests: $tests"
+       for test in $tests; do
+               local cmd="./runtests -N $cnt_NRUN $test -f $testdir"
+               local rc=0
+
+               log "$cmd"
+               eval $cmd
+               rc=$?
+               [ $rc = 0 ] || error "connectathon failed: $rc"
+       done
 
-    cd $savePWD
-    rm -rf $testdir
+       cd $savePWD
+       rm -rf $testdir
 }
 
 run_ior() {
        local type=${1:="ssf"}
+       local dir=${2:-$DIR}
+       local testdir=$dir/d0.ior.$type
+       local nfs_srvmntpt=$3
+
+       if [ "$NFSCLIENT" ]; then
+               [[ -n $nfs_srvmntpt ]] ||
+                       { error "NFSCLIENT mode, but nfs exported dir"\
+                               "is not set!" && return 1; }
+       fi
 
        IOR=${IOR:-$(which IOR 2> /dev/null || true)}
+       [ x$IOR = x ] &&
+               { skip_env "IOR not found" && return; }
+
        # threads per client
        ior_THREADS=${ior_THREADS:-2}
        ior_iteration=${ior_iteration:-1}
@@ -573,11 +597,8 @@ run_ior() {
                        ;;
        esac
 
-       [ x$IOR = x ] &&
-        { skip_env "IOR not found" && return; }
-
        # calculate the space in bytes
-       local space=$(df -B 1 -P $DIR | tail -n 1 | awk '{ print $4 }')
+       local space=$(df -B 1 -P $dir | tail -n 1 | awk '{ print $4 }')
        local total_threads=$((num_clients * ior_THREADS))
        echo "+ $ior_blockSize * $multiplier * $total_threads "
        if [ $((space / 2)) -le \
@@ -592,19 +613,17 @@ run_ior() {
                     ${ior_blockUnit} bytes)"
        fi
 
-    print_opts IOR ior_THREADS ior_DURATION MACHINEFILE
+       print_opts IOR ior_THREADS ior_DURATION MACHINEFILE
+
+       mkdir -p $testdir
+       # mpi_run uses mpiuser
+       chmod 0777 $testdir
+       if [ -z "$NFSCLIENT" ]; then
+               ior_stripe_params=${ior_stripe_params:-"-c -1"}
+               $LFS setstripe $testdir $ior_stripe_params ||
+                       { error "setstripe failed" && return 2; }
+       fi
 
-    local testdir=$DIR/d0.ior.$type
-    mkdir -p $testdir
-    # mpi_run uses mpiuser
-    chmod 0777 $testdir
-    if [ "$NFSCLIENT" ]; then
-        setstripe_nfsserver $testdir -c -1 ||
-            { error "setstripe on nfsserver failed" && return 1; }
-    else
-        $LFS setstripe $testdir -c -1 ||
-            { error "setstripe failed" && return 2; }
-    fi
        #
        # -b N  blockSize --
        #       contiguous bytes to write per task (e.g.: 8, 4K, 2M, 1G)"
@@ -617,9 +636,14 @@ run_ior() {
        # -T    maxTimeDuration -- max time in minutes to run tests"
        # -k    keepFile -- keep testFile(s) on program exit
 
-       local cmd="$IOR -a $ior_type -b ${ior_blockSize}${ior_blockUnit} \
+       local cmd
+       if [ -n "$ior_custom_params" ]; then
+               cmd="$IOR $ior_custom_params -o $testdir/iorData"
+       else
+               cmd="$IOR -a $ior_type -b ${ior_blockSize}${ior_blockUnit} \
                -o $testdir/iorData -t $ior_xferSize -v -C -w -r -W \
                -i $ior_iteration -T $ior_DURATION -k"
+       fi
 
        [ $type = "fpp" ] && cmd="$cmd -F"
 
@@ -630,8 +654,9 @@ run_ior() {
                        -n $((num_clients * ior_THREADS)) -p $SRUN_PARTITION \
                        -- $cmd
        else
+               mpi_ior_custom_threads=${mpi_ior_custom_threads:-"$((num_clients * ior_THREADS))"}
                mpi_run ${MACHINEFILE_OPTION} ${MACHINEFILE} \
-                       -np $((num_clients * $ior_THREADS)) $cmd
+                       -np $mpi_ior_custom_threads $cmd
        fi
 
     local rc=$?
@@ -780,20 +805,21 @@ run_write_append_truncate() {
 }
 
 run_write_disjoint() {
+       if [ "$NFSCLIENT" ]; then
+               skip "skipped for NFSCLIENT mode"
+               return
+       fi
 
-    WRITE_DISJOINT=${WRITE_DISJOINT:-$(which write_disjoint \
-        2> /dev/null || true)}
-    # threads per client
-    wdisjoint_THREADS=${wdisjoint_THREADS:-4}
-    wdisjoint_REP=${wdisjoint_REP:-10000}
+       WRITE_DISJOINT=${WRITE_DISJOINT:-$(which write_disjoint 2> /dev/null ||
+                                          true)}
 
-    if [ "$NFSCLIENT" ]; then
-        skip "skipped for NFSCLIENT mode"
-        return
-    fi
+       [ x$WRITE_DISJOINT = x ] &&
+               { skip_env "write_disjoint not found" && return; }
 
-    [ x$WRITE_DISJOINT = x ] &&
-        { skip_env "write_disjoint not found" && return; }
+       # threads per client
+       wdisjoint_THREADS=${wdisjoint_THREADS:-4}
+       wdisjoint_REP=${wdisjoint_REP:-10000}
+       chunk_size_limit=$1
 
     # FIXME
     # Need space estimation here.
@@ -805,7 +831,8 @@ run_write_disjoint() {
     # mpi_run uses mpiuser
     chmod 0777 $testdir
 
-    local cmd="$WRITE_DISJOINT -f $testdir/file -n $wdisjoint_REP"
+       local cmd="$WRITE_DISJOINT -f $testdir/file -n $wdisjoint_REP -m \
+                       $chunk_size_limit"
 
        echo "+ $cmd"
        mpi_run ${MACHINEFILE_OPTION} ${MACHINEFILE} \
@@ -958,6 +985,129 @@ run_statahead () {
     cleanup_statahead $clients $mntpt_root $num_mntpts
 }
 
+cleanup_rr_alloc () {
+       trap 0
+       local clients="$1"
+       local mntpt_root="$2"
+       local rr_alloc_MNTPTS="$3"
+       local mntpt_dir=$(dirname ${mntpt_root})
+
+       for i in $(seq 0 $((rr_alloc_MNTPTS - 1))); do
+               zconf_umount_clients $clients ${mntpt_root}$i ||
+               error_exit "Failed to umount lustre on ${mntpt_root}$i"
+       done
+       do_nodes $clients "rm -rf $mntpt_dir"
+}
+
+run_rr_alloc() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
+       echo "===Test gives more reproduction percentage if number of "\
+               "client and ost are more. Test with 44 or more clients "\
+               "and 73 or more OSTs gives 100% reproduction rate=="
+
+       RR_ALLOC=${RR_ALLOC:-$(which rr_alloc 2> /dev/null || true)}
+       [ x$RR_ALLOC = x ] && { skip_env "rr_alloc not found" && return; }
+       declare -a diff_max_min_arr
+       # foeo = file on each ost. calc = calculated.
+       local ost_idx
+       local foeo_calc
+       local qos_prec_objs="${TMP}/qos_and_precreated_objects"
+       local rr_alloc_NFILES=${rr_alloc_NFILES:-555}
+       local rr_alloc_MNTPTS=${rr_alloc_MNTPTS:-11}
+       local total_MNTPTS=$((rr_alloc_MNTPTS * num_clients))
+       local mntpt_root="${TMP}/rr_alloc_mntpt/lustre"
+       if [ $MDSCOUNT -lt 2 ]; then
+               [ -e $DIR/$tdir ] || mkdir -p $DIR/$tdir
+       else
+               [ -e $DIR/$tdir ] || $LFS mkdir -i 0 $DIR/$tdir
+       fi
+       chmod 0777 $DIR/$tdir
+       $SETSTRIPE -c 1 /$DIR/$tdir
+
+       trap "cleanup_rr_alloc $clients $mntpt_root $rr_alloc_MNTPTS" EXIT ERR
+       for i in $(seq 0 $((rr_alloc_MNTPTS - 1))); do
+               zconf_mount_clients $clients ${mntpt_root}$i $MOUNT_OPTS ||
+               error_exit "Failed to mount lustre on ${mntpt_root}$i $clients"
+       done
+
+       local cmd="$RR_ALLOC $mntpt_root/$tdir/ash $rr_alloc_NFILES \
+               $num_clients"
+
+       # Save mdt values, set threshold to 100% i.e always Round Robin,
+       # restore the saved values again after creating files...
+       save_lustre_params mds1 \
+               "lov.$FSNAME-MDT0000*.qos_threshold_rr" > $qos_prec_objs
+       save_lustre_params mds1 \
+               "osp.$FSNAME-OST*-osc-MDT0000.create_count" >> $qos_prec_objs
+
+       local old_create_count=$(grep -e "create_count" $qos_prec_objs |
+               cut -d'=' -f 2 | sort -nr | head -n1)
+
+       # Make sure that every osp has enough precreated objects for the file
+       # creation app
+
+       # create_count is always set to the power of 2 only, so if the files
+       # per OST are not multiple of that then it will be set to nearest
+       # lower power of 2. So set 'create_count' to the upper power of 2.
+
+       foeo_calc=$((rr_alloc_NFILES * total_MNTPTS / OSTCOUNT))
+       local create_count=$((2 * foeo_calc))
+       do_facet mds1 "$LCTL set_param -n \
+               lov.$FSNAME-MDT0000*.qos_threshold_rr 100 \
+               osp.$FSNAME-OST*-osc-MDT0000.create_count $create_count" ||
+               error "failed while setting qos_threshold_rr & creat_count"
+
+       # Create few temporary files in order to increase the precreated objects
+       # to a desired value, before starting 'rr_alloc' app. Due to default
+       # value 32 of precreation count (OST_MIN_PRECREATE=32), precreated
+       # objects available are 32 initially, these gets exhausted very soon,
+       # which causes skip of some osps when very large number of files
+       # is created per OSTs.
+       createmany -o $DIR/$tdir/foo- $(((old_create_count + 1) * OSTCOUNT)) \
+               > /dev/null
+       rm -f /$DIR/$tdir/foo*
+
+       # Check for enough precreated objects... We should not
+       # fail here because code(osp_precreate.c) also takes care of it.
+       # So we have good chances of passing test even if this check fails.
+       local mdt_idx=0
+       for ost_idx in $(seq 0 $((OSTCOUNT - 1))); do
+               [[ $(precreated_ost_obj_count $mdt_idx $ost_idx) -ge \
+                       $foeo_calc ]] || echo "Warning: test may fail because" \
+                       "of lack of precreated objects on OST${ost_idx}"
+       done
+
+       if [[ $total_MNTPTS -ne 0 ]]; then
+               # Now start the actual file creation app.
+               mpi_run "-np $total_MNTPTS" $cmd || return
+       else
+               error "No mount point"
+       fi
+
+       restore_lustre_params < $qos_prec_objs
+       rm -f $qos_prec_objs
+
+       diff_max_min_arr=($($GETSTRIPE -r $DIR/$tdir/ |
+               grep "lmm_stripe_offset:" | awk '{print $2}' | sort -n |
+               uniq -c | awk 'NR==1 {min=max=$1} \
+               { $1<min ? min=$1 : min; $1>max ? max=$1 : max} \
+               END {print max-min, max, min}'))
+
+       rm -rf $DIR/$tdir
+
+       # In-case of fairly large number of file creation using RR (round-robin)
+       # there can be two cases in which deviation will occur than the regular
+       # RR algo behaviour-
+       # 1- When rr_alloc does not start right with 'lqr_start_count' reseeded,
+       # 2- When rr_alloc does not finish with 'lqr_start_count == 0'.
+       # So the difference of files b/w any 2 OST should not be more than 2.
+       [[ ${diff_max_min_arr[0]} -le 2 ]] ||
+               error "Uneven distribution detected: difference between" \
+               "maximum files per OST (${diff_max_min_arr[1]}) and" \
+               "minimum files per OST (${diff_max_min_arr[2]}) must not be" \
+               "greater than 2"
+}
+
 run_fs_test() {
        # fs_test.x is the default name for exe
        FS_TEST=${FS_TEST:=$(which fs_test.x 2> /dev/null || true)}
@@ -1055,3 +1205,123 @@ ior_mdtest_parallel() {
        [[ $rc1 -ne 0 || $rc2 -ne 0 ]] && return 1
        return 0
 }
+
+run_fio() {
+       FIO=${FIO:=$(which fio 2> /dev/null || true)}
+
+       local clients=${CLIENTS:-$(hostname)}
+       local fio_jobNum=${fio_jobNum:-4}
+       local fio_jobFile=${fio_jobFile:-$TMP/fiojobfile.$(date +%s)}
+       local fio_bs=${fio_bs:-1}
+       local testdir=$DIR/d0.fio
+       local file=${testdir}/fio
+       local runtime=60
+       local propagate=false
+
+       [ "$SLOW" = "no" ] || runtime=600
+
+       [ x$FIO = x ] &&
+               { skip_env "FIO not found" && return; }
+
+       mkdir -p $testdir
+
+       # use fio job file if exists,
+       # create a simple one if missing
+       if ! [ -f $fio_jobFile ]; then
+               cat >> $fio_jobFile <<EOF
+[global]
+rw=randwrite
+size=128m
+time_based=1
+runtime=$runtime
+filename=${file}_\$(hostname)
+EOF
+               # bs size increased by $i for each job
+               for ((i=1; i<=fio_jobNum; i++)); do
+                       cat >> $fio_jobFile <<EOF
+
+[job$i]
+bs=$(( fio_bs * i ))m
+EOF
+               done
+               # job file is created, should be propagated to all clients
+               propagate=true
+       fi
+
+
+       # propagate the job file if not all clients have it yet or
+       # if the job file was created during the test run
+       if ! do_nodesv $clients " [ -f $fio_jobFile ] " ||
+          $propagate; then
+               local cfg=$(cat $fio_jobFile)
+               do_nodes $clients "echo \\\"$cfg\\\" > ${fio_jobFile}" ||
+                       error "job file $fio_jobFile is not propagated"
+               do_nodesv $clients "cat ${fio_jobFile}"
+       fi
+
+       cmd="$FIO $fio_jobFile"
+       echo "+ $cmd"
+
+       log "clients: $clients $cmd"
+
+       local rc=0
+       do_nodesv $clients "$cmd "
+       rc=$?
+
+       [ $rc = 0 ] || error "fio failed: $rc"
+       rm -rf $testdir
+}
+
+run_xdd() {
+       XDD=${XDD:=$(which xdd 2> /dev/null || true)}
+
+       local clients=${CLIENTS:-$(hostname)}
+       local testdir=$DIR/d0.xdd
+       xdd_queuedepth=${xdd_queuedepth:-4}
+       xdd_blocksize=${xdd_blocksize:-512}
+       xdd_reqsize=${xdd_reqsize:-128}
+       xdd_mbytes=${xdd_mbytes:-100}
+       xdd_passes=${xdd_passes:-40}
+       xdd_rwratio=${xdd_rwratio:-0}
+       xdd_ntargets=${xdd_ntargets:-6}
+       local xdd_custom_params=${xdd_custom_params:-"-dio -stoponerror \
+               -maxpri -minall -noproclock -nomemlock"}
+
+       [ x$XDD = x ] &&
+               { skip "XDD not found" && return; }
+
+       print_opts XDD clients xdd_queuedepth xdd_blocksize xdd_reqsize \
+               xdd_mbytes xdd_passes xdd_rwratio
+
+       mkdir -p $testdir
+
+       local files=""
+       # Target files creates based on the given number of targets
+       for (( i=0; i < $xdd_ntargets; i++ ))
+       do
+               files+="${testdir}/xdd"$i" "
+       done
+
+       # -targets      specifies the devices or files to perform operation
+       # -reqsize      number of 'blocks' per operation
+       # -mbytes       number of 1024*1024-byte blocks to transfer
+       # -blocksize    size of a single 'block'
+       # -passes       number of times to read mbytes
+       # -queuedepth   number of commands to queue on the target
+       # -rwratio      percentage of read to write operations
+       # -verbose      will print out statistics on each pass
+
+       local cmd="$XDD -targets $xdd_ntargets $files -reqsize $xdd_reqsize \
+               -mbytes $xdd_mbytes -blocksize $xdd_blocksize \
+               -passes $xdd_passes -queuedepth $xdd_queuedepth \
+               -rwratio $xdd_rwratio -verbose $xdd_custom_params"
+       echo "+ $cmd"
+
+       local rc=0
+       do_nodesv $clients "$cmd "
+       rc=$?
+
+       [ $rc = 0 ] || error "xdd failed: $rc"
+
+       rm -rf $testdir
+}